Bug 1056711 - Backport new IPv6 address flag IFA_F_NOPREFIXROUTE and IFA_F_MANAGETEMPADDR
Summary: Backport new IPv6 address flag IFA_F_NOPREFIXROUTE and IFA_F_MANAGETEMPADDR
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: kernel
Version: 20
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Jiri Pirko
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1045118 1047139
TreeView+ depends on / blocked
 
Reported: 2014-01-22 18:35 UTC by Thomas Haller
Modified: 2015-05-05 01:24 UTC (History)
10 users (show)

Fixed In Version: kernel-3.12.9-201.fc19
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-02-03 02:49:28 UTC


Attachments (Terms of Use)

Description Thomas Haller 2014-01-22 18:35:25 UTC
Please backport two new IPv6 address flags IFA_F_NOPREFIXROUTE and IFA_F_MANAGETEMPADDR.

These address flags make use of the extended 32bit ifa-flags and are currently in net-next (and will probably be in 3.14 kernel).

These flags are needed to help NetworkManager doing SLAAC in user space. Currently, this has two limitations that cannot be fixed without these flags:

- ipv6-private addresses cannot be supported and do not work in F20 as of now (if NetworkManager is used).

- autoconf addresses are /64, but depending on the "onlink" property from the router announcement, no /64 prefix route should be added for this address. Currently, NetworkManager works around this by adding the addresses as /128, which is at least unexpected (see NM bug 1044590 for RHEL-7, bug 1045118 for F20).

A same patches are backported for RHEL-7, see bug 1052884

Comment 1 Jiri Pirko 2014-01-23 17:27:40 UTC
patch posted here:

https://lists.fedoraproject.org/pipermail/kernel/2014-January/004840.html

Comment 2 Fedora Update System 2014-01-27 23:58:51 UTC
kernel-3.12.9-300.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/kernel-3.12.9-300.fc20

Comment 3 Fedora Update System 2014-01-27 23:59:26 UTC
kernel-3.12.9-200.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/kernel-3.12.9-200.fc19

Comment 4 Fedora Update System 2014-01-29 03:11:16 UTC
Package kernel-3.12.9-300.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing kernel-3.12.9-300.fc20'
as soon as you are able to, then reboot.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2014-1726/kernel-3.12.9-300.fc20
then log in and leave karma (feedback).

Comment 5 Fabrice Bellet 2014-01-29 13:23:33 UTC
Hi!

it seems this update breaks net-snmp, with the modification implied in /proc/net/if_inet6 (the flags fields now has 3 digits instead of 2):

[root@lxorgfr ~]# cat /proc/net/if_inet6 
fe80000000000000021e4ffffe95b492 03 40 20 80      em1
00000000000000000000000000000001 01 80 10 80       lo
fe80000000000000021018fffe317280 02 40 20 80     p4p1

[bellet@bonobo ~]$ cat /proc/net/if_inet6 
00000000000000000000000000000001 01 80 10 080       lo
fe80000000000000f2def1fffea1e042 04 40 20 080      em1

and snmpd expects only 2 digits while parsing it in _load_v6() (from ip-mib/data_access/ipaddress_linux.c).

this causes the if_name to be incorrectly parsed, and repeated messages in /var/log/messages:

Jan 29 13:53:26 localhost snmpd[20332]: ioctl 35123 returned -1
Jan 29 13:53:26 localhost snmpd[20332]: ioctl 35123 returned -1
Jan 29 13:53:27 localhost snmpd[20332]: ioctl 35123 returned -1
Jan 29 13:53:27 localhost snmpd[20332]: ioctl 35123 returned -1
Jan 29 14:06:36 localhost snmpd[20332]: ioctl 35123 returned -1

Comment 6 Jiri Pirko 2014-01-29 13:39:19 UTC
Fabrice, thank you. I missed to backport:

commit 971a351ccbbd2b6eef136a2221da0b80aca50906
Author: Jiri Pirko <jiri@resnulli.us>
Date:   Tue Dec 10 13:56:29 2013 +0100

    ipv6 addrconf: revert /proc/net/if_inet6 ifa_flag format

Will send it in a jiff.

Comment 7 Jiri Pirko 2014-01-29 14:02:17 UTC
fix posted here:

https://lists.fedoraproject.org/pipermail/kernel/2014-January/004852.html

Comment 8 Fedora Update System 2014-01-31 04:25:14 UTC
Package kernel-3.12.9-301.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing kernel-3.12.9-301.fc20'
as soon as you are able to, then reboot.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2014-1726/kernel-3.12.9-301.fc20
then log in and leave karma (feedback).

Comment 9 Josh Boyer 2014-01-31 12:24:23 UTC
Jiri, any ideas on this one?

Comment 10 Fedora Update System 2014-02-03 02:49:28 UTC
kernel-3.12.9-301.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 11 Fedora Update System 2014-02-04 02:48:57 UTC
kernel-3.12.9-201.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.